/*
 *	main.c
 *
 *	* Mon Jan 14 06:04:00 JST 2002 Naoyuki Sawa
 *	- 쐬JnB
 */
#include <simple.h>
#include <string.h>
/* siprintf()printstr()0x80ȍ~̕ɑΉĂȂ(gĂ܂)̂ŁA
 * pclSpriteBGPutCharacter()𒼐ڌĂяo𓾂ȂB
 */
#include <pclsprite.h>

/****************************************************************************
 *	萔
 ****************************************************************************/

/* XvCgp^[ */
#define CHR_TOFU0	0x01	/*  */
#define CHR_TOFU1	0x02
#define CHR_TOFU2	0x03
#define CHR_TOFU3	0x04
#define CHR_TOFU4	0x05
#define CHR_MARU0	0x88	/*  */
#define CHR_MARU1	0x89
#define CHR_MARU2	0x8A
#define CHR_MARU3	0x8B
#define CHR_MARU4	0x8C
#define CHR_MARU5	0x8D
#define CHR_MARU6	0x8E
#define CHR_MARU7	0x8F

/* XvCgv[ */
#define SPR_KOMA	0
#define SPR_CURSOR	49

/*  */
#define DISP_COLS	16
#define DISP_ROWS	11

/* tB[h */
#define FIELD_X		2
#define FIELD_Y		2
#define FIELD_COLS	7
#define FIELD_ROWS	7

/* CtH[V */
#define INFO_X		11
#define INFO_Y		 2

/* R} */
#define PLAYER		1
#define CPU		2

#define THINK_DEPTH	1	/* ǂ݂Ȃ...(^^; */
//#define DISP_THINK

/****************************************************************************
 *	O[oϐ
 ****************************************************************************/

int timer;

int pad_stat;	/* pbh */
int pad_trig;	/* pbhgK */

int kosi_pat[2] = { CHR_TOFU0, CHR_TOFU1 };
int koma_pat[3] = { 0, CHR_MARU6, CHR_MARU7 };
char* koma_str[3] = { "", "YOU", "CPU" };
int cursor_pat[4] = { 0, CHR_TOFU0, 0, CHR_TOFU3 };

typedef char FIELD[FIELD_ROWS][FIELD_COLS];
FIELD field;

/****************************************************************************
 *	period
 ****************************************************************************/

void
period()
{
	int old;

	timer++;

	old = pad_stat;
	pad_stat = pad();
	pad_trig = (pad_stat ^ old) & pad_stat;
}

/****************************************************************************
 *	draw_field
 ****************************************************************************/

/* tB[h̃x[X`܂B
 * Q[JnɌĂłB
 */
void
draw_field()
{
	int x, y;

	/* ܂Aʂ܂B */
	cls();

	/* g`܂B */
	for(y = -1; y < FIELD_ROWS + 1; y++) {
		for(x = -1; x < FIELD_COLS + 1; x++) {
			locate(FIELD_X + x, FIELD_Y + y);
			siprintf("%c", CHR_TOFU4);
		}
	}

	/* iq`܂B */
	for(y = 0; y < FIELD_ROWS; y++) {
		for(x = 0; x < FIELD_COLS; x++) {
			locate(FIELD_X + x, FIELD_Y + y);
			siprintf("%c", kosi_pat[(x ^ y) & 1]);
		}
	}
}

/****************************************************************************
 *	update_field
 ****************************************************************************/

/* tB[h̃R}`܂B
 * R}̏ԂωƂɌĂłB
 */
void
update_field()
{
	int spr, x, y;

	/* R}`܂B */
	spr = SPR_KOMA;
	for(y = 0; y < FIELD_ROWS; y++) {
		for(x = 0; x < FIELD_COLS; x++) {
			spdisp(spr, 8 * (FIELD_X + x), 8 * (FIELD_Y + y),
				koma_pat[(int)field[y][x]]);
			spr++;
		}
	}
}

/****************************************************************************
 *	init_field
 ****************************************************************************/

/* tB[h܂B
 * Q[JnɌĂłB
 */
void
init_field()
{
	memset(field, 0, sizeof(FIELD));
	field[0             ][0             ] = CPU;
	field[FIELD_ROWS - 1][FIELD_COLS - 1] = CPU;
	field[0             ][FIELD_COLS - 1] = PLAYER;
	field[FIELD_ROWS - 1][0             ] = PLAYER;
}

/****************************************************************************
 *	title
 ****************************************************************************/

void
title()
{
	cls();

	/* ^Cg\B */
	locate(2, 4);
	siprintf("Simple ATAXX");

	/* X^[g҂B */
	while(!(pad_trig & PAD_A)) {
		locate(1, 6);
		if((timer & 7) < 5) {
			siprintf("PRESS A BUTTON");
		} else {
			siprintf("              ");
		}

		period();
		wait(100);
	}
}

/****************************************************************************
 *	check_move_koma
 ****************************************************************************/

/* ړ\ȃR}邩ׂ܂B
 */
int
check_move_koma(FIELD field, int koma)
{
	int x_src, y_src, x_dst, y_dst;

	/* ̃R}T܂B */
	for(y_src = 0; y_src < FIELD_ROWS; y_src++) {
		for(x_src = 0; x_src < FIELD_COLS; x_src++) {
			if(field[y_src][x_src] != koma) continue;

			/* c2}Xȓɋ󔒂΁Aړ\łB */
			for(y_dst = y_src - 2; y_dst <= y_src + 2; y_dst++) {
				if(y_dst < 0 || FIELD_ROWS <= y_dst) continue;
				for(x_dst = x_src - 2; x_dst <= x_src + 2; x_dst++) {
					if(x_dst < 0 || FIELD_COLS <= x_dst) continue;

					if(field[y_dst][x_dst] == 0) {
//locate(0, 10);
//siprintf("%d,%d,%d,%d", x_src, y_src, x_dst, y_dst);
						return 1;
					}
				}
			}
		}
	}

	return 0;
}

/****************************************************************************
 *	move_koma
 ****************************************************************************/

/* R}ړ܂͕܂B
 */
void
move_koma(FIELD field, int x_src, int y_src, int x_dst, int y_dst)
{
	/* ړɃR}u܂B */
	field[y_dst][x_dst] = field[y_src][x_src];

	/* c1}Xȓ̈ړłȂ΁Aړ̃R}܂B */
	if(abs(x_dst - x_src) > 1 || abs(y_dst - y_src) > 1) {
		field[y_src][x_src] = 0;
	}
}

/****************************************************************************
 *	flip_koma
 ****************************************************************************/

int flip_koma_pos[8][2] = {
	{ -1, -1 }, /*  */
	{  0, -1 }, /*    */
	{  1, -1 }, /* E */
	{  1,  0 }, /* E   */
	{  1,  1 }, /* E */
	{  0,  1 }, /*    */
	{ -1,  1 }, /*  */
	{ -1,  0 }, /*    */
};
#define N_FLIP_KOMA_POS (sizeof flip_koma_pos / sizeof *flip_koma_pos)

int
flip_koma(FIELD field, int x_center, int y_center)
{
	int koma, enemy, i, x, y;

	/* ̃R}Ƒ̃R}߂܂B */
	koma = field[y_center][x_center];
	enemy = koma == PLAYER ? CPU : PLAYER;

	/* ̂܂̈ʒu𒲂ׂ... */
	for(i = 0; i < N_FLIP_KOMA_POS; i++) {
		x = x_center + flip_koma_pos[i][0];
		y = y_center + flip_koma_pos[i][1];
		if(x < 0 || FIELD_COLS <= x || y < 0 || FIELD_ROWS <= y) continue;

		/* ̃R}A]1ԂB
		 * (́ǍĂяoŒׂ܂)
		 */
		if(field[y][x] == enemy) {
			field[y][x] = koma;
			return 1;
		}
	}

	/* ̂܂ɑ̃R}Ȃ΁A0Ԃ܂B */
	return 0;
}

/****************************************************************************
 *	count_koma
 ****************************************************************************/

int
count_koma(FIELD field, int koma)
{
	int count, x, y;

	count = 0;
	for(y = 0; y < FIELD_ROWS; y++) {
		for(x = 0; x < FIELD_COLS; x++) {
			if(field[y][x] == koma) count++;
		}
	}
	return count;
}

/****************************************************************************
 *	show_info
 ****************************************************************************/

void
show_info(int koma, const char* info)
{
	int x, y;

	x = INFO_X;
	y = INFO_Y;

	locate(x, y);
	siprintf("%-4s", koma_str[koma]);
	y += 2;
	locate(x, y);
	siprintf("%4s", info != NULL ? info : "");
	y += 2;
	locate(x, y);
	pclSpriteBGPutCharacter(koma_pat[PLAYER]);
	siprintf("%3d", count_koma(field, PLAYER));
	y += 2;
	locate(x, y);
	pclSpriteBGPutCharacter(koma_pat[CPU]);
	siprintf("%3d", count_koma(field, CPU));
}

/****************************************************************************
 *	check_end
 ****************************************************************************/

int
check_end(FIELD field)
{
	int player, cpu;

	player = count_koma(field, PLAYER);
	cpu = count_koma(field, CPU);
	if(player == 0 || cpu == 0 || player + cpu == FIELD_ROWS * FIELD_COLS) return 1;

	return 0;
}

/****************************************************************************
 *	think
 ****************************************************************************/

int
think(FIELD field, int koma, int depth, int* x_src_result, int* y_src_result, int* x_dst_result, int* y_dst_result, int* pass_result)
{
	FIELD f_tmp;
	int pass, value, value_max, player, cpu;
	int x_src, y_src, x_dst, y_dst;

	value_max = 0; /*x}*/

	/* łR}΁A0ɂȂ܂B */
	pass = 1;

	/* tB[h̎̃R}ꂼɂ... */
	for(y_src = 0; y_src < FIELD_ROWS; y_src++) {
		for(x_src = 0; x_src < FIELD_COLS; x_src++) {
			if(field[y_src][x_src] != koma) continue;
#ifdef DISP_THINK
if(pass_result != NULL) spdisp(SPR_CURSOR + 0, (FIELD_X + x_src) * 8, (FIELD_Y + y_src) * 8, CHR_TOFU3);
#endif /*DISP_THINK*/

			/* ̃R}ړ\Ȉʒuꂼɂ... */
			for(y_dst = y_src - 2; y_dst <= y_src + 2; y_dst++) {
				if(y_dst < 0 || FIELD_ROWS <= y_dst) continue;
				for(x_dst = x_src - 2; x_dst <= x_src + 2; x_dst++) {
					if(x_dst < 0 || FIELD_COLS <= x_dst) continue;
					if(field[y_dst][x_dst] != 0) continue;
#ifdef DISP_THINK
if(pass_result != NULL) spdisp(SPR_CURSOR + 1, (FIELD_X + x_dst) * 8, (FIELD_Y + y_dst) * 8, CHR_TOFU3);
#endif /*DISP_THINK*/

					/* R}ړĂ݂܂B */
					memcpy(f_tmp, field, sizeof(FIELD));
					move_koma(f_tmp, x_src, y_src, x_dst, y_dst);
					while(flip_koma(f_tmp, x_dst, y_dst))
						;

					/* R}𐔂܂B */
					player = count_koma(f_tmp, PLAYER);
					cpu = count_koma(f_tmp, CPU);

					/* sH */
					if(player + cpu == FIELD_COLS * FIELD_ROWS) {
						if(koma == PLAYER) {
							if(player > cpu) {
								value = FIELD_COLS * FIELD_ROWS;
							} else if(cpu > player) {
								value = -FIELD_COLS * FIELD_ROWS;
							} else {
								value = 0;
							}
						} else {
							if(player > cpu) {
								value = -FIELD_COLS * FIELD_ROWS;
							} else if(cpu > player) {
								value = FIELD_COLS * FIELD_ROWS;
							} else {
								value = 0;
							}
						}

					/* ǂݐ[xEH */
					} else if(depth == 0) {
						if(koma == PLAYER) {
							value = player - cpu;
						} else {
							value = cpu - player;
						}

					} else {
						if(koma == PLAYER) {
							value = -think(f_tmp, CPU, depth - 1, NULL, NULL, NULL, NULL, NULL);
						} else {
							value = -think(f_tmp, PLAYER, depth - 1, NULL, NULL, NULL, NULL, NULL);
						}
					}

					/* ܂͂ǂȂA̗p܂B */
					if(pass || value > value_max) {
						pass = 0;
						value_max = value;
						if(x_src_result != NULL) *x_src_result = x_src;
						if(y_src_result != NULL) *y_src_result = y_src;
						if(x_dst_result != NULL) *x_dst_result = x_dst;
						if(y_dst_result != NULL) *y_dst_result = y_dst;
					}
				}
			}
		}
	}

	/* pXȂ... */
	if(pass) {
		/* ǂݐ[xEȂA]B */
		if(depth == 0) {
			player = count_koma(field, PLAYER);
			cpu = count_koma(field, CPU);
			if(koma == PLAYER) {
				value_max = player - cpu;
			} else {
				value_max = cpu - player;
			}

		} else {
			if(koma == PLAYER) {
				value_max = -think(field, CPU, depth - 1, NULL, NULL, NULL, NULL, NULL);
			} else {
				value_max = -think(field, PLAYER, depth - 1, NULL, NULL, NULL, NULL, NULL);
			}
		}
	}

#ifdef DISP_THINK
if(pass_result != NULL) {
	spchr(SPR_CURSOR + 0, 0);
	spchr(SPR_CURSOR + 1, 0);
}
#endif /*DISP_THINK*/

	if(pass_result != NULL) *pass_result = pass;
	return value_max;
}

/****************************************************************************
 *	game
 ****************************************************************************/

void
game()
{
	int i, koma, player, cpu, pass;
	int player_x_src, player_y_src, player_x_dst, player_y_dst;
	int cpu_x_src, cpu_y_src, cpu_x_dst, cpu_y_dst;

	/* tB[h܂B */
	init_field();
	draw_field();
	update_field();

	/* ړ̏lB */
	player_x_src = 0;
	player_y_src = FIELD_ROWS - 1;

	for(;;) {
/* vC[̔ԁB */
koma = PLAYER;

		/* ړ\ǂׂ܂B */
		if(!check_move_koma(field, koma)) {
			show_info(koma, "SKIP");
			goto PLAYER_SKIP;
		}

PLAYER_CANCEL:
		/* ړ肵܂B */
		show_info(koma, "ORIG");
		for(;;) {
			/* XLbvB */
			if(pad_trig & PAD_B) {
				spchr(SPR_CURSOR + 0, 0);
				show_info(koma, "SKIP");
				period();
				goto PLAYER_SKIP;
			}

			/* vC[̃R}̏A{^ꂽAړłB */
			if(pad_trig & PAD_A) {
				if(field[player_y_src][player_x_src] == koma) break;
			}

			/* J[\ړB */
			if((player_x_src > 0             ) && (pad_trig & PAD_LF)) player_x_src--;
			if((player_x_src < FIELD_COLS - 1) && (pad_trig & PAD_RI)) player_x_src++;
			if((player_y_src > 0             ) && (pad_trig & PAD_UP)) player_y_src--;
			if((player_y_src < FIELD_ROWS - 1) && (pad_trig & PAD_DN)) player_y_src++;

			/* J[\\B */
			spdisp(SPR_CURSOR + 0, (FIELD_X + player_x_src) * 8, (FIELD_Y + player_y_src) * 8, cursor_pat[timer & 3]);

			wait(50);
			period();
		}
		period();

		/* ړ̏l͈ړƓB */
		player_x_dst = player_x_src;
		player_y_dst = player_y_src;

		/* ړ肵܂B */
		show_info(koma, "DEST");
		for(;;) {
			/* LZB */
			if(pad_trig & PAD_B) {
				spchr(SPR_CURSOR + 1, 0);
				period();
				goto PLAYER_CANCEL;
			}

			/* ړ2}Xȓ̋󂫈ʒuw肳ꂽAړ挈łB */
			if(pad_trig & PAD_A) {
				if(abs(player_x_dst - player_x_src) <= 2 &&
				   abs(player_y_dst - player_y_src) <= 2 &&
				   field[player_y_dst][player_x_dst] == 0) break;
			}

			/* J[\ړB */
			if((player_x_dst > 0             ) && (abs((player_x_dst - 1) - player_x_src) <= 2) && (pad_trig & PAD_LF)) player_x_dst--;
			if((player_x_dst < FIELD_COLS - 1) && (abs((player_x_dst + 1) - player_x_src) <= 2) && (pad_trig & PAD_RI)) player_x_dst++;
			if((player_y_dst > 0             ) && (abs((player_y_dst - 1) - player_y_src) <= 2) && (pad_trig & PAD_UP)) player_y_dst--;
			if((player_y_dst < FIELD_ROWS - 1) && (abs((player_y_dst + 1) - player_y_src) <= 2) && (pad_trig & PAD_DN)) player_y_dst++;

			/* J[\\B */
			spdisp(SPR_CURSOR + 0, (FIELD_X + player_x_src) * 8, (FIELD_Y + player_y_src) * 8, cursor_pat[timer & 3]);
			spdisp(SPR_CURSOR + 1, (FIELD_X + player_x_dst) * 8, (FIELD_Y + player_y_dst) * 8, cursor_pat[timer & 3]);

			wait(50);
			period();
		}
		period();

		/* J[\B */
		spchr(SPR_CURSOR + 0, 0);
		spchr(SPR_CURSOR + 1, 0);

		/* R}ړ܂B */
		move_koma(field, player_x_src, player_y_src, player_x_dst, player_y_dst);
		update_field();
		show_info(koma, "MOVE");
		wait(250);

		/* ̃R}𔽓]܂B */
		while(flip_koma(field, player_x_dst, player_y_dst)) {
			update_field();
			show_info(koma, "FLIP");
			wait(50);
		}

		/* ړ̏l͍̈ړB */
		player_x_src = player_x_dst;
		player_y_src = player_y_dst;
PLAYER_SKIP:
		wait(250);
		if(check_end(field)) break;

/* CPU̔ԁB */
koma = CPU;

		/* ړ\ǂׂ܂B */
		if(!check_move_koma(field, koma)) {
			show_info(koma, "SKIP");
			wait(250);
			goto CPU_SKIP;
		}

		/* ړAړ肵܂B */
		show_info(koma, "THNK");
		think(field, koma, THINK_DEPTH, &cpu_x_src, &cpu_y_src, &cpu_x_dst, &cpu_y_dst, &pass);
		if(pass) goto CPU_SKIP;

		/* R}ړ܂B */
		move_koma(field, cpu_x_src, cpu_y_src, cpu_x_dst, cpu_y_dst);
		update_field();
		show_info(koma, "MOVE");
		wait(250);

		/* ̃R}𔽓]܂B */
		while(flip_koma(field, cpu_x_dst, cpu_y_dst)) {
			update_field();
			show_info(koma, "FLIP");
			wait(50);
		}
CPU_SKIP:
		wait(250);
		if(check_end(field)) break;
	}
	period();

	/* sB */
	player = count_koma(field, PLAYER);
	cpu = count_koma(field, CPU);
	for(;;) {
		/* A{^ꂽ甲܂B */
		if(pad_trig & PAD_A) break;

		/* s_ŕ\B */
		if((timer & 7) < 5) {
			if(player > cpu) {
				show_info(PLAYER, "WIN!");
			} else if(cpu > player) {
				show_info(CPU, "WIN!");
			} else {
				show_info(0, "DRAW");
			}
		} else {
			show_info(0, NULL);
		}

		period();
		wait(100);
	}
	period();

	/* XvCg܂B */
	for(i = 0; i < 64; i++) spchr(i, 0);
}

/****************************************************************************
 *	smain
 ****************************************************************************/

void
smain()
{
	/* C[vB */
	for(;;) {
		title();
		period();

		game();
		period();
	}
}
